PUPPET-DOC(8)

NAME
puppet-doc - Generate Puppet documentation and references

SYNOPSIS
Generates a reference for all Puppet types. Largely meant for internal Puppet Labs use.

USAGE
puppet doc [-a|--all] [-h|--help] [-o|--outputdir rdoc-outputdir] [-m|--mode text|pdf|rdoc] [-r|--reference reference-name] [--charset charset] [manifest-file]

DESCRIPTION
If mode is not 'rdoc', then this command generates a Markdown document describing all installed Puppet types or all allowable arguments to puppet executables. It is largely meant for internal use and is used to generate the reference document available on the Puppet Labs web site.

In 'rdoc' mode, this command generates an html RDoc hierarchy describing the manifests that are in 'manifestdir' and 'modulepath' configuration directives. The generated documentation directory is doc by default but can be changed with the 'outputdir' option.

If the command is run with the name of a manifest file as an argument, puppet doc will output a single manifest's documentation on stdout.

OPTIONS

--all
    Output the docs for all of the reference types. In 'rdoc' mode, this also outputs documentation for all resources.

--help
    Print this help message

--outputdir
    Used only in 'rdoc' mode. The directory to which the rdoc output should be written.

--mode
    Determine the output mode. Valid modes are 'text', 'pdf' and 'rdoc'. The 'pdf' mode creates PDF formatted files in the /tmp directory. The default mode is 'text'. In 'rdoc' mode you must provide 'manifests-path'

--reference
    Build a particular reference. Get a list of references by running 'puppet doc --list'.

--charset
    Used only in 'rdoc' mode. It sets the charset used in the html files produced.

--manifestdir
    Used only in 'rdoc' mode. The directory to scan for stand-alone manifests. If not supplied, puppet doc will use the manifestdir from puppet.conf.

--modulepath
    Used only in 'rdoc' mode. The directory or directories to scan for modules. If not supplied, puppet doc will use the modulepath from puppet.conf.

--environment
    Used only in 'rdoc' mode. The configuration environment from which to read the modulepath and manifestdir settings, when reading said settings from puppet.conf. Due to a known bug, this option is not currently effective.

EXAMPLE
$ puppet doc -r type > /tmp/type_reference.markdown

or

    $ puppet doc --outputdir /tmp/rdoc --mode rdoc /path/to/manifests

or

    $ puppet doc /etc/puppet/manifests/site.pp

or

    $ puppet doc -m pdf -r configuration

AUTHOR
Luke Kanies

COPYRIGHT
Copyright (c) 2011 Puppet Labs, LLC Licensed under the Apache 2.0 License